import java.util.ArrayList;
import java.util.Collections;

public class Sortieren
{
    public static int[] insertionSort(int[] a)
    {
        ArrayList<Integer> listeSort = new ArrayList<>();
        
        for(int i:a)
           fuegeSortiertEin(listeSort,i);
        
        for(int i=0; i<listeSort.size(); i++)
           a[i] = listeSort.get(i);   
           
        return a;
    }
    
    /**
     * fuegt x sortiert in liste ein
     */
    public static void fuegeSortiertEin(ArrayList<Integer> liste, int x)
    {
        for(int i=0; i<liste.size(); i++)
        {
            if(x<liste.get(i))
            {
                 liste.add(i,x);
                 return;
            }
        }
        
        liste.add(x);
    }
    
    
    
    public static int[] bubbleSort(int[] a)
    {
        boolean nochmal = true;
        
        while(nochmal){
        
            nochmal = vertausche(a);
        }
        
        return a;
    }
    
    
    public static boolean vertausche(int[] a)
    {
        boolean vertauscht = false;
        
        for(int i=0; i<a.length-1; i++)
        {
            if(a[i]>a[i+1])
            {
                vertausche(a,i,i+1);
                vertauscht = true;
            }
        }
        
        return vertauscht;
    }
    
    /**
     * vertauscht Elemente i und j in a
     */
    public static void vertausche(int[] a, int i, int j)
    {
            int hilf = a[i];
            a[i] = a[j];
            a[j] = hilf;
    
    }
    
    public static int[] selectionSort(int[] a)
    {
        for(int i=0; i<a.length; i++)
        {
            // suche i-kleinstes Element ab Index i
            int index = getMin(a,i);
            
            // vertausche i-tes Element mit i-kleinstem
            vertausche(a, i, index);
        }
        
        return a;
        
    }
    
    /**
     * sucht kleinstes Element in a ab Index index
     * gibt entsprechenden Index in a zurueck
     */
    public static int getMin(int[] a, int index)
    {
        int minIndex = index;
        
        for(int i=index; i<a.length; i++)
        {
            if(a[i]<a[minIndex])
               minIndex = i;
        }
        
        return minIndex;
    }
}
